//
// Model.cpp
//
#include "stdafx.h"

#include "Model.h"

void CModel::MakeArray()
{
	DestroyArray();

	if( 0 == m_vIndexedTriangle.size() )
	{
		return;
	}

	// Op`_z
	unsigned int uiCountData = m_vIndexedTriangle.size() * 3 * 3;	// P̎Op`́AR_BP_͂RWlB
	m_afTriangleVertex = new float[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vIndexedTriangle.size(); uiIndexTriangle++ )
	{
		m_afTriangleVertex[uiIndexTriangle * 9 + 0] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].x;
		m_afTriangleVertex[uiIndexTriangle * 9 + 1] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].y;
		m_afTriangleVertex[uiIndexTriangle * 9 + 2] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].z;
		m_afTriangleVertex[uiIndexTriangle * 9 + 3] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].x;
		m_afTriangleVertex[uiIndexTriangle * 9 + 4] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].y;
		m_afTriangleVertex[uiIndexTriangle * 9 + 5] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].z;
		m_afTriangleVertex[uiIndexTriangle * 9 + 6] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].x;
		m_afTriangleVertex[uiIndexTriangle * 9 + 7] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].y;
		m_afTriangleVertex[uiIndexTriangle * 9 + 8] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].z;
	}

	// Ő_ԍz
	uiCountData = m_vIndexedTriangle.size() * 3 * 2;	// ̎Op`́AR̗ŐBP̗Ő́AQ̒_B
	m_auiEdgeVertexIndex = new unsigned int[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vIndexedTriangle.size(); uiIndexTriangle++ )
	{
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 0] = uiIndexTriangle * 3 + 0;
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 1] = uiIndexTriangle * 3 + 1;
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 2] = uiIndexTriangle * 3 + 1;
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 3] = uiIndexTriangle * 3 + 2;
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 4] = uiIndexTriangle * 3 + 2;
		m_auiEdgeVertexIndex[uiIndexTriangle * 6 + 5] = uiIndexTriangle * 3 + 0;
	}
}

void CModel::DestroyArray()
{
	if( m_auiEdgeVertexIndex )
	{
		delete m_auiEdgeVertexIndex;
	}
	if( m_afTriangleVertex )
	{
		delete m_afTriangleVertex;
	}
}
